;*******************************************************************************
;;/plugg/ Joint arc et lignes sous forme de polyligne /none
(pw_pluggin_register '( "convert&join2pline" ("LINE" "ARC")("convertie arc et ligne en polyligne jointe" "-" "convert and join arc and line to single polyline" )))

;;definition de la commande - function definition
(defun convert&join2pline ( / sel lobj l lpsel)
 (command "_pedit" "_m" "_p" "" "_y" "_j" pause "")
)  
;*******************************************************************************
;;/plugg/ convertie polylignes lisse en spline - convert pline to spline/none
;; register this plug-in for polylines  entities
(pw_pluggin_register '( "convertospline" ("POLYLINE")("convertie polylignes lisse en spline" "-" "convert pline to spline" )))

;;definition de la commande - function definition
(defun convertospline ( / sel lobj l lpsel)
 (setq sel (ssget "_p"))
 (setq lobj (pw_listsel sel))
 (foreach l lobj
   (if (member 4 (pw_l_flag (cdr (assoc 70 (entget l)))))
    (progn
     (setq pt (car (pw_lsomm3d l)))
     (setq lpsel (cons (list l pt) lpsel))
    )
   )
 )
 (foreach l lpsel
   (command "_splinedit" l "_refine" ""  "")
 )
)
;*******************************************************************************
;;/plugg/ convertie polylignes 3d en poly 2d - convert 3d pline to 2d pline/none
;; register this plug-in for polylines  entities
(pw_pluggin_register '( "conver_to_new_2Dpline" ("POLYLINE")("convertie polylignes 3D en polyline 2D" "-" "convert 3D pline to Lwpolyline 2D" )))

;;definition de la commande - function definition
(defun conver_to_new_2Dpline (/ sel lobj l lpsel)
  (setq sel (ssget "_p"))
  (setq lobj (pw_listsel sel))
  (foreach l lobj
    (setq lpt (pw_lsomm l))
    (command "_pline")
    (foreach pt	lpt
      (command pt)
    )
    (command "")
  )
)
;;*************************
;;/plugg/cree une multiligne sur une polyligne /lsom
(pw_pluggin_register '("Duplicate_as_mline" ( "POLYLINE" "LWPOLYLINE" "MLINE" "RECTANG" "POLYGONE" "3DFACE")( "Cre une multiligne passant pas les sommet de l'objet" "Style calque echelle et justification sont les parametres courants" "--" "Draw an mline on each vertex of the entity" "Layer, style, scale and justification are current settings")))
;
;
(defun Duplicate_as_mline ( / sel lent l i pins ent lpt)
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (pw_setvar1 "attreq" 0)
  (pw_setvar1 "osmode" 0)  
  (foreach l lent
    (setq i (+ 1 i))
    (setq lpt (pw_lsomm_obj_3d l))
    (setq lpt  (mapcar 'PW_scg2scu  lpt))
    (command "_MLINE")
     
    (foreach pins lpt
     (command  pins  )
    )
    (command "")
   
  )
  (pw_setvar2 "attreq" )
  (pw_setvar2 "osmode" )
)

;*******************************************************************************
;/plugg/ inserre un point au point d'insertion/none
;
(pw_pluggin_register '("point_on_vertex" ( "POLYLINE" "LWPOLYLINE" "MLINE" "RECTANG" "POLYGONE" "3DFACE")( "insere un point au sommet des segments" "Draw a nodal on each vertex")))

(defun point_on_vertex ( / sel lent l i  pins lpt )
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (pw_setvar1 "attreq" 0)
  (pw_setvar1 "osmode" 0)  
  (foreach l lent
    (setq i (+ 1 i))
    (setq lpt (pw_lsomm_obj_3d l))
    (setq lpt  (mapcar 'PW_scg2scu  lpt))
    (foreach pins lpt
    (command "_point"  pins  )
    )
   
  )
  (pw_setvar2 "attreq" )
  (pw_setvar2 "osmode" )

)
;*******************************************************************************
;; width2weight
;;/plugg/convert pline width to plot weight /none
;; register this plug-in for entities that have a width
(pw_pluggin_register '("width2weight" ("POLYLINE" "LWPOLYLINE" "REGION" "RECTANG" "POLYGONE" )("Convertie largeur polyligne en paisseur de ligne" "" "convert pline width to plot weight" )))
;;definition de la commande - function definition
(defun width2weight ( / sel1 l eg  x  l-scale width1)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 ;;selection obtenue avant (par powerclic)
 (pw_getkwordmem "\nSet ltscale same that width ? /Yes No" "plu-setscale")  

 (foreach l sell
  (setq eg (entget l))
  (setq width1 (cdr (assoc 40 eg)))
  (setq eg (pw_subst_all (cons 40  0.0)(assoc 40 eg) eg))
  (setq eg (pw_subst_all (cons 41  0.0)(assoc 41 eg) eg))
  (setq eg (pw_subst_ou_aj 43 0.0 eg))
  (setq width1 (pw_real2indexed (* 100 width1) PW-LWEIGHT100))
  (setq eg (pw_subst_ou_aj 370 width1 eg ))
  (if (= (strcase plu-setscale  "YES"))
   (setq eg (subst (cons 48 (/ width1 100.0))(assoc 48 eg) eg))
  )
  (entmod eg)
  (entupd l)
 )
)

;*******************************************************************************
;; weight2width
;;/plugg/convert plot weight to pline width  /none
;; register this plug-in for entities that have a width
(pw_pluggin_register '("weight2width" ("POLYLINE" "LWPOLYLINE" "REGION" "RECTANG" "POLYGONE" ) ("Convertie paisseur de ligne en largeur polyligne" "" "convert plot weight to pline width" )))
;;definition de la commande - function definition
(defun weight2width ( / sel1 l eg  x  l-scale width1)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 ;;selection obtenue avant (par powerclic)
 (pw_getkwordmem "\nSet ltscale same that width ? /Yes No" "plu-setscale")  

 (foreach l sell
  (setq eg (entget l))
  (setq width1 (cdr (assoc 370 eg)))
  (if (>= width1 0)
    (progn
      (setq width1 (/ width1 100.0))
      (setq eg (pw_subst_all (cons 40  width1)(assoc 40 eg) eg))
      (setq eg (pw_subst_all (cons 41  width1)(assoc 41 eg) eg))
      (setq eg (pw_subst_ou_aj 43 width1 eg))
      (if (= (strcase plu-setscale  "YES"))
	(setq eg (pw_subst_ou_aj 48 width1 eg))
      )
      (entmod eg)
      (entupd l)
    )
  )
 )
)
;*******************************************************************************
;; same_ltscale_than_weight
;;/plugg/force entities ltscale to their weight value/none
;; register this plug-in for entities that have a width
(pw_pluggin_register '( "same_ltscale_than_weight" ("SPLINE" "POLYLINE" "LWPOLYLINE" "LINE" "REGION" "RECTANG" "POLYGONE"  "CIRCLE" "ELLIPSE")("force entities ltscale to their weight value")))
;;definition de la commande - function definition
(defun same_ltscale_than_weight ( / sel1 l eg   l-scale width1)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 (foreach l sell
  (setq eg (entget l))
  (setq width1 (cdr (assoc 370 eg)))
  (if (> width1 0)
    (progn
      (setq width1 (/ width1 100.0))
      (setq eg (pw_subst_ou_aj 48 width1 eg))
      (entmod eg)
      (entupd l)
    )
  )
 )
)
;*******************************************************************************
;; same_ltscale_than_width
;;/plugg/force entities ltscale to their width value/none
;; register this plug-in for entities that have a width
(pw_pluggin_register '("same_ltscale_than_width" ("POLYLINE" "LWPOLYLINE" "REGION" "RECTANG" "POLYGONE" )("force entities ltscale to their width value")))
;;definition de la commande - function definition
(defun same_ltscale_than_width ( / sel1 l eg   l-scale width1)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 (foreach l sell
  (setq eg (entget l))
  (setq width1 (cdr (assoc 40 eg)))
  (if (> width1 0)
    (progn
      (setq eg (pw_subst_ou_aj 48 width1 eg))
      (entmod eg)
      (entupd l)
    )
  )
 )
)

;*******************************************************************************
;; calculate_area
;;/plugg/Addition of entities aera/none
;; register this plug-in for entities that have a width
(pw_pluggin_register '("calculate_area" ("POLYLINE" "LWPOLYLINE" "REGION" "RECTANG" "POLYGONE"  "CIRCLE" "ELLIPSE")("Addition of entities aera" )))
;;definition de la commande - function definition
(defun calculate_area ( / sell l res)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 (setq res 0)

 (foreach l sell
                 (pw_setvar1 "cmdecho" 0)
		 (command "_area" "_object" l )
		 (setq res (+ res (getvar "area")))
		(pw_setvar2 "cmdecho" )
 )
 (prompt "\n Surface totale calculee en units dessin :")
 (prin1 res )
)
;*******************************************************************************
;;/plugg/Addition of straight entities length/none
(pw_pluggin_register '("calculate_straight_length" ("POLYLINE" "LWPOLYLINE" "MLINE" "RECTANG" "POLYGONE" )("Addition of entities length" "without taking care of curves and arcs")))
;;definition de la commande - function definition
(defun calculate_straight_length ( /  res)
 ;;selection obtenue avant (par powerclic)
 (setq res (pw_lin_jslong (ssget "_p")))
 (prompt "\n Longueur totale calculee en units dessin :")
 (prin1 res )
)

;*******************************************************************************
;;/plugg/Addition of curved entities length/none
(pw_pluggin_register '("calculate_curve_length" ("POLYLINE" "LWPOLYLINE"  "SPLINE" "ELIPSE" "CIRCLE")("Addition of entities length" "taking care of curves and arcs")))
;;definition de la commande - function definition
(defun calculate_curve_length ( /  res)
 ;;selection obtenue avant (par powerclic)
 (setq res (pw_spl_jslong (ssget "_p")))
 (prompt "\n Longueur totale calculee en units dessin :")
 (prin1 res )
)
;;*******************************************************************
;;/plugg/ hachure les element ferms  partir d'une taille - hatch closed element according to their dimension/none
;;hachure  partir d'une certaine taille
;; enregistre le plug-in pour les polylignes, les lwpolylignes 
(pw_pluggin_register '("select_by_length" ("POLYLINE" "LWPOLYLINE" "RECTANG" "POLYGONE" "MLINE") ("selectionne des entits   partir d'une taille" "-" "select polylines according to their dimension" )))

;;definition de la commande - function definition
(defun select_by_length ( /  selobj sel lobj l  ss long )
  (pw_getstringmem "\nMinimum length value * for none" "pw-min-length")
  (pw_getstringmem "\nMaximum length value * for none" "pw-max-length")

 (setq selobj (ssget "_p" ))
 (setq lobj (pw_listsel selobj))
 (setq sel (ssadd))
 (foreach l lobj
     ;;(setq ss (pw_selist (list l)))
     ;(setq long (pw_lin_jslong ss))
      (setq long (PW_LONG_POL l))
      (cond ((= "*" pw-min-length)
	   (if (<= zmax (read pw-max-length))
	     (setq sel (ssadd l sel))
	   )
	  )
          ((= "*" pw-max-length)
	   (if (>= long (read pw-min-length))
	     (setq sel (ssadd l sel))
	   )
	  )
          (T
	   (if (and (>= long (read pw-min-length))(<= long (read pw-max-length)))
	     (setq sel (ssadd l sel))
	   )
	  )
      )
 )
 (sssetfirst sel sel)
)
;*******************************************************************************
;;/poly/Ouvre une polyligne en gardant la mme geomtrie/none
(pw_pluggin_register '("open_poly" ( "LWPOLYLINE" "RECTANG" "POLYGONE" "DONUT" )("Ouvre une polyligne en gardant la mme geomtrie" "open a polyline keeping same geometry")))
(defun open_poly ( / sell l res eg dir nbs p1)
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel  (setq sel (ssget "_p" (list  '(-4 . "<OR")'(70 . 1)'(70 . 129)'(-4 . "OR>"))))))

 (foreach l sell
  (setq eg (entget l))
  (setq p1 (assoc 10 eg))
  (setq nbs (+ 1 (cdr (assoc 90 eg))))
  (setq eg (pw_subst_ou_aj 90 nbs eg));;nombre
  (setq eg (pw_subst_ou_aj 70 0 eg));;ferm
  (setq dir (assoc 210 eg))
  (setq eg (pw_supp_elem dir eg));;direction
  (setq eg (append eg (list p1 '(40 . 0.0) '(41 . 0.0) '(42 . 0.0))))
  (entmod eg)
  (entupd l)
 )
)
;*******************************************************************************
;;/poly/selectionne les polylignes fermes/none
(pw_pluggin_register '("select_closed_ones" ( "LWPOLYLINE"  "POLYLINE")("selectionne les polylignes fermes" "-" "Select closed polylines" )))
(defun select_closed_ones ( / sel l sell flag)
 ;;selection obtenue avant (par powerclic)
 (setq sel (pw_listsel (ssget "_p")))
 (setq sell (ssadd))
 (foreach l sel
  (setq eg (entget l))
  (setq flag (cdr (assoc 70 eg)))
  (if (member 1 (pw_l_flag flag))
   (setq sell (ssadd l sell ))    
  )
 )
 (sssetfirst sell sell)
 
)
